#ifndef Lib_Columns_h
#define Lib_Columns_h 

namespace Slash {namespace Core {class IWriter;}}
#include <string>
#include <list>

#include <Lib/Value.h>
#include <Lib/ColumnsLexer.h>

namespace Lib {

class Columns {
public:
  Columns(const std::string&,Slash::Core::IWriter&,int = 0);
  virtual ~Columns();
  Columns& operator=(const Columns&);
  void setScript(const std::string&);
  bool findVariables();
  std::list<Lib::Value> result() const;
  void clear(); 
  std::string script() const;
  bool isSuccess() const;
public:  // Internal :
  const ColumnsLexer& lexer() const;
  Slash::Core::IWriter& printer() const;
public:
  static void deleteColumns(std::list<Lib::Value>&);
  static void copyColumns(const std::list<Lib::Value>&,
                          std::list<Lib::Value>&);
public:
  int fVerboseLevel;
  std::string fString;
  Slash::Core::IWriter& fPrinter;
  std::list<Lib::Value> fStack;
  ColumnsLexer fLexer;
  bool fSuccess;
  Slash::Core::IValue::Type fCurrentType;
  std::vector<Lib::Value*> fTmpVars;
  std::string fError;
};

}

#endif
