#ifndef Lib_Manager_h
#define Lib_Manager_h

#include <Slash/Core/ISession.h>
#include <Slash/Core/IManager.h>
#include <Slash/Core/IWriter.h>

namespace Lib {

template <class aT> 
inline aT* findManager(
 Slash::Core::ISession& aSession
,const std::string& aName
,const std::string& aCast
) 
{
  Slash::Core::IManager* manager = aSession.findManager(aName);
  if(!manager) {
    //Slash::Core::IWriter& printer = aSession.printer();
    //printer.write("Lib::findManager : ");
    //printer.write("\""+aName+"\" not found.\n");
    return 0;
  }
#if defined(__linux)
  // Python shell (2.3.3) looses the dynamic_cast on the DLL modules !
  // Then we stay with our "safe cast".
  aT* mgr = (aT*)manager->cast(aCast);
#else
  aT* mgr = dynamic_cast<aT*>(manager);
#endif
  if(!mgr) {
    Slash::Core::IWriter& printer = aSession.printer();
    printer.write("Lib::findManager : ");
    printer.write("\""+aName+"\" cast to  \""+aCast+"\" failed.\n");
  }
  return mgr;
}

}


#define Lib_findManager(aSession,aName,aClass) Lib::findManager<aClass>(aSession,aName,#aClass)

#endif
