#ifndef Lib_ObjectReader_h
#define Lib_ObjectReader_h

// Inheritance :
#include <Slash/Store/IVisitor.h>

namespace Lib {

class ObjectReader : public virtual Slash::Store::IVisitor {
public: //Slash::Store::IVisitor
  virtual bool begin(Slash::Store::IStorable&);
  virtual bool end(Slash::Store::IStorable&);
  virtual bool visit(bool&);
  virtual bool visit(char&);
  virtual bool visit(short&);
  virtual bool visit(int&);
  virtual bool visit(Slash::int64&);
  virtual bool visit(unsigned int&);
  virtual bool visit(float&);
  virtual bool visit(double&);
  virtual bool visit(std::string&);
  virtual bool visit(std::vector<bool>&);
  virtual bool visit(std::vector<char>&);
  virtual bool visit(std::vector<short>&);
  virtual bool visit(std::vector<int>&);
  virtual bool visit(std::vector<Slash::int64>&);
  virtual bool visit(std::vector<float>&);
  virtual bool visit(std::vector<double>&);
  virtual bool visit(std::vector<unsigned char>&);
  virtual bool visit(std::vector<std::string>&);
  virtual bool visit(std::vector< std::vector<double> >&);
  virtual bool visit_double(Slash::Store::IArray&);
  virtual Slash::Core::ISession& session();
public:
  ObjectReader(Slash::Core::ISession&,char*& pos,char* end);
  virtual ~ObjectReader();  
private:
  Slash::Core::ISession& fSession;
  char*& fPos;
  char* fEnd;
};

}

#endif
