#ifndef Lib_OpaqueManager_h
#define Lib_OpaqueManager_h

#include <list>

#include <Slash/Core/IManager.h>
#include <Slash/Core/IOpaqueManager.h>

namespace Lib {

class OpaqueManager;

class OpaqueProxy {
  //friend class OpaqueManager;
public:
  OpaqueProxy(OpaqueManager&,void*,const std::string&,bool);
  OpaqueProxy(const OpaqueProxy&);
  virtual ~OpaqueProxy();
  OpaqueProxy& operator=(const OpaqueProxy&);
  bool isOwner() const;
  void* object() const;
  const std::string& identifier() const;
private:
  OpaqueManager& fManager;
  void* fObject;
  std::string fID;
  bool fOwner;
};

bool operator==(const OpaqueProxy&,const OpaqueProxy&);

class OpaqueManager 
:public virtual Slash::Core::IManager
,public virtual Slash::Core::IOpaqueManager {
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //IObjectManager
  virtual void* find(const std::string&) const;
  virtual bool add(void*,const std::string&,bool = false);
  virtual bool isOwner(const std::string&) const;
  virtual bool destroy(const std::string&);
public:
  OpaqueManager(const std::string&);
  virtual ~OpaqueManager();
private:
  std::list<OpaqueProxy> fList;
  std::string fName;
};

}

#endif
